#define OS_MAIN

#include <pic.h>
#include <jacos.h>
#include "\jacos\prim\prim_io.h"


OST_TASK task1;
OST_TASK task2;
OST_TASK task3;


unsigned char counter;

//------------------------------------------------------------------------------
__task void T_1(void)
{
  while (1) {
    counter++;
    OS_Cooperate();
    counter++;
  }
}

//------------------------------------------------------------------------------
__task void T_2(void)
{
  while (1) {
    counter++;
    OS_Cooperate();
    counter++;
  }
}

//------------------------------------------------------------------------------
__task void T_3(void)
{
  while (1) {
    counter++;
    OS_Cooperate();
    counter++;
  }
}

//------------------------------------------------------------------------------
int main(void)
{
  OS_Init();
  OS_Task_Create(T_1, &task1, 1);
  OS_Task_Create(T_2, &task2, 2);
  OS_Task_Create(T_3, &task3, 3);

  while (1) {
    asm(" clrwdt ");
    OS_Scheduler();
  }
}

