#include <salvo.h>








#define TASK_T1_P   OSTCBP(1)
#define TASK_T2_P   OSTCBP(2)
#define TASK_T3_P   OSTCBP(3)


/* Define labels for context switching	*/
_OSLabel(TASK_T1_L)
_OSLabel(TASK_T2_L)
_OSLabel(TASK_T3_L)

/* Define bin semaphores */


unsigned char Counter;

//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////

void Task_T1 (void)
{
    for(;;){
        Counter++;
        OS_Yield(TASK_T1_L);
        Counter++;
    }
}
//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////

void Task_T2 (void)
{
    for(;;){
        Counter++;
        OS_Yield(TASK_T2_L);
        Counter++;
    }
}
//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////

void Task_T3 (void)
{
    for(;;){
        Counter++;
        OS_Yield(TASK_T3_L);
        Counter++;
    }
}

//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////

void main()
{
    OSInit();
    OSCreateTask(Task_T1,  TASK_T1_P, 5);
    OSCreateTask(Task_T2,  TASK_T2_P, 5);
    OSCreateTask(Task_T3,  TASK_T3_P, 5);

    for(;;){
        asm(" clrwdt ");
        OSSched();
    }
}
