#define OS_MAIN


#define OS_OPTI_SEMT	//    OS_Wait_Sem()  OS_Wait_SemT()
#define OS_OPTI_DELAY	//  OS_Delay()

#include <jacos.h>

#include "\jacos\prim\prim_io.h"


OST_TASK_T task1;
OST_TASK_T task2;
OST_TASK_T task3;

OST_SEMAPHORE  event1;
OST_SEMAPHORE  event2;
OST_SEMAPHORE  event3;


unsigned char counter;

//------------------------------------------------------------------------------
__task void T_1(void)
{
  while (1) {
    OS_Delay(10);
    OS_Post_BSem(&event1);
    counter++;
    OS_Cooperate();
    counter++;
    OS_Wait_Sem(&event2);
  }
}

//------------------------------------------------------------------------------
__task void T_2(void)
{
  while (1) {
    OS_Delay(10);
    OS_Post_BSem(&event2);
    counter++;
    OS_Cooperate();
    counter++;
    OS_Wait_SemT(&event3, 100);
  }
}

//------------------------------------------------------------------------------
__task void T_3(void)
{
  while (1) {
    OS_Delay(10);
    OS_Post_BSem(&event3);
    counter++;
    OS_Cooperate();
    counter++;
    OS_Wait_SemT(&event1, 100);
  }
}

//------------------------------------------------------------------------------
int main(void)
{
  OS_Init();
  OS_Task_Create(T_1, &task1, 1);
  OS_Task_Create(T_2, &task2, 1);
  OS_Task_Create(T_3, &task3, 1);

  OS_Sem_Create(&event1,0);
  OS_Sem_Create(&event2,0);
  OS_Sem_Create(&event3,0);

  while (1) {
    asm(" clrwdt ");
    OS_Timer();
    OS_Scheduler();
  }
}

