#define OS_MAIN

#define OS_OPTI_SEMT	//    OS_Wait_Sem()  OS_Wait_SemT()
#define OS_OPTI_MSGT	//  OS_Wait_Msg()  OS_Wait_MsgT()
#define OS_OPTI_MSGQT	//  OS_Wait_MsgQ()  OS_Wait_MsgQT()
#define OS_OPTI_DELAY	//  OS_Delay()

#include <jacos.h>
#include "\jacos\prim\prim_io.h"


OST_TASK_T task1;
OST_TASK_T task2;
OST_TASK_T task3;

OST_MSGQUEUE 	        msgq;
OST_MSGQ_DESCR    mqdscr;
OST_MSG_P 	mbuff[5];

unsigned char counter;


//------------------------------------------------------------------------------
__task void T_1(void)
{
  OST_MSG_P msgp;
  while (1) {
    counter++;
    OS_Cooperate();
    counter++;
    OS_Post_MsgQ(&msgq, msgp);
  }
}

//------------------------------------------------------------------------------
__task void T_2(void)
{
  OST_MSG_P msgp;
  while (1) {
    counter++;
    OS_Cooperate();
    counter++;
    OS_Wait_MsgQ(&msgq, msgp);
  }
}

//------------------------------------------------------------------------------
__task void T_3(void)
{
  OST_MSG_P msgp;
  while (1) {
    counter++;
    OS_Cooperate();
    counter++;
    OS_Wait_MsgQT(&msgq, msgp, 100);
  }
}

//------------------------------------------------------------------------------
int main(void)
{
  OS_Init();
  OS_Task_Create(T_1, &task1, 1);
  OS_Task_Create(T_2, &task2, 2);
  OS_Task_Create(T_3, &task3, 3);


  OS_MsgQ_Create(&msgq, &mqdscr, 5, mbuff);  
  
  while (1) {
    asm(" clrwdt ");
    OS_Timer();
    OS_Scheduler();
  }
}

