#include <salvo.h>








#define TASK_T1_P   OSTCBP(1)
#define TASK_T2_P   OSTCBP(2)
#define TASK_T3_P   OSTCBP(3)


/* Define labels for context switching	*/
_OSLabel(TASK_T1_L)
_OSLabel(TASK_T2_L)
_OSLabel(TASK_T3_L)

_OSLabel(TASK_T1_L2)
_OSLabel(TASK_T2_L2)
_OSLabel(TASK_T3_L2)

_OSLabel(TASK_T1_L3)
_OSLabel(TASK_T2_L3)
_OSLabel(TASK_T3_L3)





/* Define bin semaphores */
#define MSGQ1_P     OSECBP(1)
#define MQCB1_P     OSMQCBP(1)
OSgltypeMsgQP buf[5];


unsigned char Counter;
//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////

void Task_T1 (void)
{
    for(;;){
        Counter++;
        OS_Yield(TASK_T1_L);
        Counter++;
        OSSignalMsgQ(MSGQ1_P, (OStypeMsgP)buf);
    }
}
//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////

void Task_T2 (void)
{
    OStypeMsgP msgp;
    for(;;){
        Counter++;
        OS_Yield(TASK_T2_L);
        Counter++;
        OS_WaitMsgQ(MSGQ1_P, msgp, OS_NOTIMEOUT, TASK_T2_L2);
    }
}
//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////

void Task_T3 (void)
{
    OStypeMsgP msgp;
    for(;;){
        Counter++;
        OS_Yield(TASK_T3_L);
        Counter++;
        OS_WaitMsgQ(MSGQ1_P, msgp, 100, TASK_T3_L2);
    }
}

//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////

void main()
{
    OSInit();
    OSCreateTask(Task_T1,  TASK_T1_P, 5);
    OSCreateTask(Task_T2,  TASK_T2_P, 5);
    OSCreateTask(Task_T3,  TASK_T3_P, 5);


    for(;;){
        asm(" clrwdt ");
        OSTimer();
        OSSched();
    }
}
